<?php
header("Content-Type: text/html;charset=utf-8");

class cls_Prestamo {

	private $db_nombre = "prestamo";
	private $db_nombrevista = "prestamo";
	private $db_filas = "*";
	private $prestamo_id = 0;
	private $almacen_tienda_id = 0;
	private $producto_id = 0;
	private $tienda_origen_id = 0;
	private $tienda_destino_id = 0;
	private $cantidad = 0;
	private $fecha_prestamo = "";
	private $fecha_devolucion = "";
	
	public function __construct(){
		$this->db_filas = "prestamo_id, almacen_tienda_id, producto_id, tienda_origen_id, tienda_destino_id, cantidad, fecha_prestamo, fecha_devolucion, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
	}

	static public function Indice($codigo){
		$current = new cls_Prestamo();
		$conn = new cls_Conexion();
		$filtro = "prestamo_id = ?";
		$values = array();
		array_push($values, $codigo );
		$lista = $conn->buscar_datos($current->db_nombrevista, $current->db_filas, $filtro, $values, "");
		$current->db_mensaje = $conn->getMensaje();
		for ($indice=0; $indice<count($lista); $indice++){
			$current->prestamo_id = $lista[$indice]["prestamo_id"];
			$current->almacen_tienda_id = $lista[$indice]["almacen_tienda_id"];
			$current->producto_id = $lista[$indice]["producto_id"];
			$current->tienda_origen_id = $lista[$indice]["tienda_origen_id"];
			$current->tienda_destino_id = $lista[$indice]["tienda_destino_id"];
			$current->cantidad = $lista[$indice]["cantidad"];
			$current->fecha_prestamo = $lista[$indice]["fecha_prestamo"];
			$current->fecha_devolucion = $lista[$indice]["fecha_devolucion"];
		}
		return $current;
	}

	public function get_prestamo_id() { return $this->prestamo_id; }
	public function get_almacen_tienda_id() { return $this->almacen_tienda_id; }
	public function get_producto_id() { return $this->producto_id; }
	public function get_tienda_origen_id() { return $this->tienda_origen_id; }
	public function get_tienda_destino_id() { return $this->tienda_destino_id; }
	public function get_cantidad() { return $this->cantidad; }
	public function get_fecha_prestamo() { return $this->fecha_prestamo; }
	public function get_fecha_devolucion() { return $this->fecha_devolucion; }
	
	public function set_prestamo_id($prestamo_id){ $this->prestamo_id = $prestamo_id; }
	public function set_almacen_tienda_id($almacen_tienda_id){ $this->almacen_tienda_id = $almacen_tienda_id; }
	public function set_producto_id($producto_id){ $this->producto_id = $producto_id; }
	public function set_tienda_origen_id($tienda_origen_id){ $this->tienda_origen_id = $tienda_origen_id; }
	public function set_tienda_destino_id($tienda_destino_id){ $this->tienda_destino_id = $tienda_destino_id; }
	public function set_cantidad($cantidad){ $this->cantidad = $cantidad; }
	public function set_fecha_prestamo($fecha_prestamo){ $this->fecha_prestamo = $fecha_prestamo; }
	public function set_fecha_devolucion($fecha_devolucion){ $this->fecha_devolucion = $fecha_devolucion; }
	
	public function registrar( ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ( $this->prestamo_id == 0 ){ // REGISTER
			array_push($values, $this->almacen_tienda_id);
			array_push($values, $this->producto_id);
			array_push($values, $this->tienda_origen_id);
			array_push($values, $this->tienda_destino_id);
			array_push($values, $this->cantidad);
			array_push($values, $this->fecha_prestamo);
			array_push($values, $this->fecha_devolucion);
			$respuesta = $conn->nuevo_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
			if ( $respuesta ){
				$this->prestamo_id = $conn->getlastId();
			}
		} else { // UPDATE
			array_push($values, $this->almacen_tienda_id);
			array_push($values, $this->producto_id);
			array_push($values, $this->tienda_origen_id);
			array_push($values, $this->tienda_destino_id);
			array_push($values, $this->cantidad);
			array_push($values, $this->fecha_prestamo);
			array_push($values, $this->fecha_devolucion);
			array_push($values, $this->prestamo_id);
			$respuesta = $conn->editar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		}
		return $respuesta;
	}
	
	public function importar( ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
			array_push($values, $this->almacen_tienda_id);
			array_push($values, $this->producto_id);
			array_push($values, $this->tienda_origen_id);
			array_push($values, $this->tienda_destino_id);
			array_push($values, $this->cantidad);
			array_push($values, $this->fecha_prestamo);
			array_push($values, $this->fecha_devolucion);
		if ($this->prestamo_id > 0){
			array_push($values, $this->prestamo_id );
		} else {
			array_push($values, NULL );
		}
		$respuesta = $conn->importar_registro($this->db_nombretabla, $values);
		$this->db_mensaje = $conn->GetMensaje();
		if ( $respuesta ){
			$this->prestamo_id = $conn->getlastId();
		};
		return $respuesta;
	}

	public function eliminar(){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ($this->prestamo_id > 0){ // DELETE
			array_push($values, $this->prestamo_id );
			$respuesta = $conn->eliminar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		} else {
			$this->db_mensaje = "No se puede realizar este proceso";
		}
		return $respuesta;
	}
}

class cls_Group_Prestamo {

	protected $db_mensaje = "";
	protected $db_nombre_tabla = "prestamo";
	protected $db_nombres_columnas = "*";
	protected $db_filtro = "1";
	protected $db_agrupar = "";
	protected $db_orden_columna = "nombre";
	protected $db_orden_direccion = "ASC";
	protected $db_cantidad = 0;
	protected $db_filtro_datos = array();
	protected $db_filas = array();
	
	public function __construct(){
		$this->db_nombres_columnas = "prestamo_id, almacen_tienda_id, producto_id, tienda_origen_id, tienda_destino_id, cantidad, fecha_prestamo, fecha_devolucion, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
		$this->db_orden_columna = "fecha_prestamo";
	}

	static public function Buscar($buscar=0, $ordendireccion="ASC", $ordencolumna="fecha_prestamo", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Prestamo();
		$current->db_filtro = "almacen_tienda_id = 0 AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $buscar );
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	public function cargar_datos( $offset, $cantidad ){
		$conn = new cls_Conexion();
		$this->db_filas = $conn->listar_filas( $this->db_nombre_tabla, $this->db_nombres_columnas, $this->db_orden_columna, $this->db_orden_direccion, $this->db_filtro, $this->db_filtro_datos, $offset, $cantidad, $this->db_agrupar );
		$this->db_mensaje = $conn->GetMensaje();
	}
	public function get_cantidad_cargados(){
		return count($this->db_filas);
	}
	public function get_cantidad(){
		return $this->db_cantidad;
	}
	
	public function get_prestamo_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["prestamo_id"];
			return $val;
		}
		return 0;
	}
	public function get_almacen_tienda_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["almacen_tienda_id"];
			return $val;
		}
		return "";
	}
	public function get_producto_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["producto_id"];
			return $val;
		}
		return "";
	}
	public function get_tienda_origen_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["tienda_origen_id"];
			return $val;
		}
		return "";
	}
	public function get_tienda_destino_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["tienda_destino_id"];
			return $val;
		}
		return "";
	}
	public function get_cantidad($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["cantidad"];
			return $val;
		}
		return 0;
	}
	public function get_fecha_prestamo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_prestamo"];
			return $val;
		}
		return "";
	}
	public function get_fecha_devolucion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_devolucion"];
			return $val;
		}
		return "";
	}
};
?>		
